/*
 Utility functions relating to applications, pids, etc.
 */

#define NM_BAD_PID ((pid_t)(-1))

#ifndef NSAppKitVersionNumber10_8
    #define NSAppKitVersionNumber10_8 1187
#endif

NSDate *NMExpireDate(NSUInteger days);

NSString *NMOwnBundleID(void);

NSString *NMBundleIdForPID(pid_t pid);

//pid_t NMPIDForBundleId(NSString *bundleId);

pid_t NMActiveApplicationPid(void);
pid_t NMFocusedApplicationPid(void);
BOOL NMOwnAppIsFocused(void);

NSString *NMOSVersionString(void);
BOOL NMOSVersionCheckSnowLeopardOrBelow();
BOOL NMOSVersionCheckLionOrBelow();
BOOL NMOSVersionCheckMountainLionOrBelow();

NSNumber *NMAppVersionNumber(void);
NSString *NMAppVersionString(void);
NSString *NMLongAppVersionString(void);

BOOL NMCheckAppInstalled(NSString *bid);



@interface NSNumber (NMPidAdditions)
+ (NSNumber *)numberWithPid:(pid_t)pid;
- (pid_t)pidValue;
@end

