//
//  NMBlockUtils.h
//  dc
//
//  Created by Work on 28/04/2011.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef void (^NMBasicBlock)(void);
typedef void (^NMOneParameterBlock)(id obj);
typedef void (^NMArrayEnumeratorBlock)(NSString *type, NSUInteger idx, BOOL *stop);
typedef BOOL (^NMBooleanBlock)(void);
typedef BOOL (^NMEvaluatorBlock)(id obj);
typedef BOOL (^NMBinaryEvaluatorBlock)(id obj1, id obj2);

void NMObserveKeyUsingBlock(id obj, NSString *key, void (^block)(NSDictionary *change));
void NMObservePrefsKeysUsingBlock(NSArray *keys, void (^block)(NSDictionary *change));
void NMObservePrefsKeyUsingBlock(NSString *key, void (^block)(NSDictionary *change));

void NMRunAsync(NMBasicBlock block);
void NMRunAsyncInBackground(NMBasicBlock block);
void NMRunAsyncOnMainThread(NMBasicBlock block);
void NMRunAsyncWithDelay(NSTimeInterval delay, NMBasicBlock block);
void NMRunAsyncOnMainThreadWithDelay(NSTimeInterval delay, NMBasicBlock block);
void NMRunSyncOnMainThread(NMBasicBlock block);

@interface NSObject (NMBlocksAdditions)
- (void)NM_callBlock;
@end

@interface NSControl (NMBlocksAdditions)
- (void)NM_setTargetBlock:(NMBasicBlock) block;
@end