//
//  NMBrowserHelper.h
//
//  Created by Nicholas Moore on 25/11/2011.
//  Copyright (c) 2011 Nicholas Moore. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString *const NMBrowserHelperIdentifierCamino;
extern NSString *const NMBrowserHelperIdentifierChrome;
extern NSString *const NMBrowserHelperIdentifierChromeCanary;
extern NSString *const NMBrowserHelperIdentifierFirefox;
extern NSString *const NMBrowserHelperIdentifierFirefoxAurora;
extern NSString *const NMBrowserHelperIdentifierOpera;
extern NSString *const NMBrowserHelperIdentifierOmniWeb;
extern NSString *const NMBrowserHelperIdentifierSafari;

@interface NMBrowserHelper : NSObject

+ (NSSet *)knownBrowsers;
+ (NSString *)defaultBrowser;
+ (NSString *)bestBrowserFromApp:(NSString *)bundleIdentifier;
+ (void)openUrl:(NSURL *)url withApp:(NSString *)bundleIdentifier;
+ (void)openUrl:(NSURL *)url fromApp:(NSString *)bundleIdentifier;
+ (BOOL)searchForText:(NSString *)searchText withApp:(NSString *)bundleIdentifier;
+ (BOOL)searchForText:(NSString *)searchText fromApp:(NSString *)bundleIdentifier;
+ (NSURL *)getFrontmostUrlForApp:(NSString *)bundleIdentifier;
+ (NSString *)getFrontmostTitleForApp:(NSString *)bundleIdentifier;

@end
