//
//  NMCoreUtils.h
//  NMKit
//
//  Created by Nicholas Moore on 28/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#ifdef __OBJC_GC__
#define NM_GC_RETAIN(expr) CFRetain(expr)
#else
#define NM_GC_RETAIN(expr) expr
#endif

#if __has_feature(objc_arc)
#define NMGCBridgingRelease CFBridgingRelease
#else
id NMGCBridgingReleaseImp(CFTypeRef ref);
#define NMGCBridgingRelease NMGCBridgingReleaseImp
#endif

NSString* NMPathWithBaseURLAndName(NSURL* base, NSString* name);
BOOL NMFileAlreadyExists(NSURL* base, NSString* name);
NSString* NMUnusedLegalNameForNewFile(NSURL* saveLocation, NSString *fileName, NSString *extension);

NSString *NMLimitString(NSString *string, NSUInteger limit, NSString *indicator);
NSString *NMURLEscapeString(NSString *str);
NSString *NMUUIDString(void);
BOOL NMUTIConformsToPlainText(NSString *uti);
BOOL NMUTIConformsToFileUrl(NSString *uti);

@interface NSArray (NMSafeFirstObject)
- (id)safeFirstObject;
- (id)safeObjectAtIndex:(NSUInteger)idx;
@end

@interface NSString (NMExtensions)
-(NSString *)removePrefix:(NSString *)requiredPrefix;
-(NSString *)stringByRemovingCharactersInSet:(NSCharacterSet *)cs;
@end

@interface NSURL (NMExtensions)
- (BOOL)isReachableFileOnlyURL;
- (BOOL)isReachableDirectoryOnlyURL;
- (BOOL)isReachableFileOrDirectoryURL;
- (BOOL)isTrashedFile;
- (NSURL *)parentURL;
- (NSArray *)allParentURLs;
- (void)removeFileAndParentIfEmpty;
@end