//
//  NMCursorUtils.h
//  NMKit
//
//  Created by nim305 on 09/08/2011.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NMSimplifiedCursor : NSObject {
    NSUInteger _pixelsPerRow;
    NSUInteger _numberOfRows;
    NSData *_data;
}
- (id)initWithAsciiArt:(NSString *)asciiArt;
- (id)initWithImage:(NSImage *)image;
@property (readonly) NSUInteger pixelsPerRow;
@property (readonly) NSUInteger numberOfRows;
@property (readonly) NSData *data;
- (NSString *)asciiArt;
- (BOOL)isBeam;
- (BOOL)isArrow;
- (BOOL)isBlank;
@end

@interface NSCursor (NMCursorUtils)
- (NSUInteger)superFastHash;
- (NMSimplifiedCursor *)simplifiedCursor;
- (NSNumber *)standardHashNum;
+ (NSNumber *)standardArrowPlaceholder;
+ (NSNumber *)standardBeamPlaceholder;
+ (NSNumber *)standardBlankPlaceholder;
@end

