//
//  NMUniversalMonitor.h
//  NMKit
//
//  Created by Nicholas Moore on 13/06/2013.
//
//

#import <Foundation/Foundation.h>
#import "NMKit/NMBlockUtils.h"

@interface NMUniversalMonitor : NSObject {
    id local;
    id global;
}

- (id)initWithMask:(NSEventMask)mask andBlock:(NMBasicBlock)block;
- (void)stopMonitor;
- (BOOL)isValid;

+ (id)monitorWithMask:(NSEventMask)mask andBlock:(NMBasicBlock)block;
+ (id)housekeepingMonitorWithImmediateRun:(BOOL)immediate repeats:(NSUInteger)repeats interval:(NSTimeInterval)interval block:(NMBasicBlock)block;
+ (id)fastHousekeepingMonitorWithBlock:(NMBasicBlock)block;

@end
